Index: lib/libpam/Makefile.inc
===================================================================
RCS file: /cvsroot/src/lib/libpam/Makefile.inc,v
retrieving revision 1.8
diff -u -p -r1.8 Makefile.inc
--- lib/libpam/Makefile.inc	11 May 2008 19:17:07 -0000	1.8
+++ lib/libpam/Makefile.inc	3 May 2010 15:49:32 -0000
@@ -28,8 +28,7 @@
 USE_FORT?= yes	# network client software *and* authentication software
 
 CPPFLAGS+= -DOPENPAM_MODULES_DIR=\"/usr/lib/security\"
-# No debugging
-#CPPFLAGS+= -DDEBUG
+CPPFLAGS+= -DDEBUG
 
 # ...and don't do either of those on the shared library.
 # XXX CSHLIBFLAGS isn't perfect, but it'll do for now.
Index: lib/libpam/modules/pam_krb5/pam_krb5.c
===================================================================
RCS file: /cvsroot/src/lib/libpam/modules/pam_krb5/pam_krb5.c,v
retrieving revision 1.21
diff -u -p -r1.21 pam_krb5.c
--- lib/libpam/modules/pam_krb5/pam_krb5.c	27 Jan 2008 01:23:20 -0000	1.21
+++ lib/libpam/modules/pam_krb5/pam_krb5.c	3 May 2010 15:49:33 -0000
@@ -562,11 +562,21 @@ pam_sm_setcred(pam_handle_t *pamh, int f
 
 	if (flags & PAM_ESTABLISH_CRED) {
 		if (strstr(cache_name, "FILE:") == cache_name) {
+#ifdef DEBUG
+ /* XXX for some strange reason, the following chown() fails when this code is
+        run by xdm(1) */
+struct stat sb;
+if (stat(&cache_name[5], &sb)) PAM_LOG("stat() failed: %s", strerror(errno));
+else PAM_LOG("stat(%s): mode %o, uid %d, gid %d", &cache_name[5], sb.st_mode, sb.st_uid, sb.st_gid);
+PAM_LOG("chown(%s, %d, %d) as euid:egid %d:%d (uid:gid %d:%d)", &cache_name[5], pwd->pw_uid, pwd->pw_gid, geteuid(), getegid(), getuid(), getgid());
+#endif /* DEBUG */
 			if (chown(&cache_name[5], pwd->pw_uid, pwd->pw_gid) == -1) {
 				PAM_LOG("Error chown(): %s", strerror(errno));
+#ifndef DEBUG
 				krb5_cc_destroy(pam_context, ccache_perm);
 				retval = PAM_SERVICE_ERR;
 				goto cleanup2;
+#endif /* !DEBUG */
 			}
 			PAM_LOG("Done chown()");
 
